/*
 * Daemonshogi -- a GTK+ based, Simple shogi(japanese chess) program.
 * Copyright (C) 2002 Masahiko Tokita
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * CharInfo class 
 * $Id: charinfo.c,v 1.1.1.1 2005/12/09 09:03:03 tokita Exp $
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/charinfo.c,v $
 */

#include <gnome.h>
#include <stdio.h>
#include "charinfo.h"
#include "daemon.xpm"


/** ǥեȤΥǡ CharInfo 롣 */
CharInfo* daemon_charinfo_new(GtkWidget* window) {
  CharInfo* info;
  
  info = malloc(sizeof(CharInfo));
  if (info == NULL) {
    printf("No enough memory in daemon_charinfo_new");
    abort();
  }
  
  daemon_charinfo_init(info);
  
  return info;
}
  
/** եեɤ߹ CharInfo 롣 */
CharInfo* dameon_charinfo_new_from_file(GtkWidget* window,
					gchar* image_file,
					gchar* words_file) {
  CharInfo* info;

  info = malloc(sizeof(CharInfo));
  if (info == NULL) {
    printf("No enough memory in daemon_charinfo_new");
    abort();
  }
  
  return info;
}

/** info  */
void daemon_charinfo_init(CharInfo* info) {
  memset(info, 0, sizeof(CharInfo));
}

/**
 * ԤμʻƲ֤
 * 
 */
GdkPixmap* daemon_charinfo_get_image(CharInfo* info, MATCH_STATE s) {
  return info->pixmap;
}

  
/**
 * Ԥμˤ碌֤
 *  last_word 򸫤Ʊ֤ʤ褦ˤ롣
 */
const gchar* daemon_charinfo_get_word(CharInfo* info, MATCH_STATE s) {
  if (info->words[s][0][0] == '\0' &&
      info->words[s][0][0] == '\0' &&
      info->words[s][0][0] == '\0' &&
      info->words[s][0][0] == '\0') {
    /* 줬Ĥʤ */
    return NULL;
  }
  
  return NULL;
}

/** ǥեȥǡ CharInfo ֤ */
CharInfo* daemon_charinfo_get_daemon(GtkWidget* window) {
  CharInfo* info;
  GdkImlibImage* im;
  gint w, h;
  
  info = daemon_charinfo_new(window);

  strncpy(info->char_name, "daemon", sizeof(info->char_name));
  
  /* ɤ */
  im = gdk_imlib_create_image_from_xpm_data(daemon_xpm);
  if (im == NULL) {
    printf("No enough memory in daemon_charinfo_get_daemon(). im is NULL\n");
    abort();
  }
  w = im->rgb_width;
  h = im->rgb_height;
  gdk_imlib_render(im, w, h);
  info->pixmap = gdk_imlib_move_image(im);
  
  strncpy(info->words[0][0], "ϡޤä", sizeof(info->words[0][0]));
  strncpy(info->words[1][0], "Ϥ줫衪", sizeof(info->words[1][0]));
  strncpy(info->words[2][0], "ϥߥ餱Τ衪", sizeof(info->words[2][0]));
  strncpy(info->words[2][1], "ϤäϤäϤá", sizeof(info->words[2][1]));
  strncpy(info->words[2][2], "⤦ꡩ", sizeof(info->words[2][2]));
  strncpy(info->words[2][3], "ᤷɥ쾭ʤΤ", sizeof(info->words[2][3]));
  strncpy(info->words[3][0], "碌Ƥä", sizeof(info->words[3][0]));
  strncpy(info->words[3][1], "䡼ˤä", sizeof(info->words[3][1]));
  strncpy(info->words[4][0], "ǧ᤿ʤΤʡ㤵椨Ρʰʲά", sizeof(info->words[4][0]));
  strncpy(info->words[4][1], "áʥ", sizeof(info->words[4][1]));
  strncpy(info->words[4][2], "ɤߤοϤηŪʺǤʤȤ򶵤Ƥ롣", sizeof(info->words[4][2]));
  strncpy(info->words[5][0], "ϤΤ餤ǴۤƤ(", sizeof(info->words[5][0]));
  strncpy(info->words[5][1], "ޤ", sizeof(info->words[5][1]));
  
  return info;
}


