/*
 * Daemonshogi -- a GTK+ based, Simple shogi(japanese chess) program.
 * Copyright (C) 2002 Masahiko Tokita
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * CharInfo class
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/charinfo.h,v $
 * $Id: charinfo.h,v 1.1.1.1 2005/12/09 09:03:03 tokita Exp $
 */

#ifndef _CHARINFO_H_
#define _CHARINFO_H_

#include <gnome.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/** жɾ֤ɽ */
typedef enum {
  /**
   * ͥξ֤ɾž줿Ȥ(ɾ15%ʾκ
   * դ
   */
  GYAKUTEN = 0,
  /**
   * ξ֤ɾžȤ(ɾ15%ʾκ
   * դȤ
   */
  GYAKUTEN2 = 1,
  /** ȿ§ڤ쾡ޤ */
  PERFECT_WIN = 2,
  /** Ϻ */
  NARROW_MARGIN = 3,
  /** Ϻ餱 */
  NARROW_DEFEAT = 4,
  /** 餱 */
  PERFECT_DEFEAT = 5,
  /** ̾ */
  NORMAL = 6
} MATCH_STATE;


/** 饯ξޤȤư饹 */
typedef struct {
  /** 饯̾ */
  gchar char_name[256];
  /** 饯β */
  GdkPixmap* pixmap;
  /** 饯 */
  gchar words[6][4][256];
  /** ֹ */
  gint last_word;
  /** 饯ζ */
  gint level;
} CharInfo;
  

/*********************************************************/
/* function prototypes */
/*********************************************************/

CharInfo*    daemon_charinfo_new          (GtkWidget* window);
CharInfo*    dameon_charinfo_new_from_file(GtkWidget* window,
					   gchar* image_file,
					   gchar* words_file);
void         daemon_charinfo_init         (CharInfo* info);
GdkPixmap*   daemon_charinfo_get_image    (CharInfo* info,
					   MATCH_STATE s);
const gchar* daemon_charinfo_get_word     (CharInfo* info,
					   MATCH_STATE s);
CharInfo*    daemon_charinfo_get_daemon   (GtkWidget* window);
  

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _CHARINFO_H_ */
