/*
 * Daemonshogi -- a GTK+ based, Simple shogi(japanese chess) program.
 * Copyright (C) 2002 Masahiko Tokita
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * DMoveInfo class
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/dmoveinfo.h,v $
 * $Id: dmoveinfo.h,v 1.1.1.1 2005/12/09 09:03:04 tokita Exp $
 */

#ifndef _DMOVEINFO_H_
#define _DMOVEINFO_H_

#include "dte.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

/** DMoveInfo Ǽκ */
#define DMOVEINFOMAX 2000

/** ؤޤȤƳǼ빽¤ */
typedef struct {
  /** ؤ */
  DTe te[DMOVEINFOMAX];
  /** ؤο */
  int count;
} DMoveInfo;

/*********************************************************/
/* function prototypes */
/*********************************************************/

DMoveInfo* daemon_dmoveinfo_new   (void);
void       daemon_dmoveinfo_init  (DMoveInfo* mi);
void       daemon_dmoveinfo_free  (DMoveInfo* mi);
void       daemon_dmoveinfo_add   (DMoveInfo* mi,
				   DTe* te);
DTe*       daemon_dmoveinfo_get   (DMoveInfo* mi,
				   int index);
DTe*       daemon_dmoveinfo_pop   (DMoveInfo* mi);
void       daemon_dmoveinfo_remove(DMoveInfo* mi,
				   int index);
void       daemon_dmoveinfo_output(DMoveInfo* mi,
				   FILE* out);
int        daemon_dmoveinfo_size  (DMoveInfo* mi);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _DMOVEINFO_H_ */
