/*
 * Daemonshogi -- a GTK+ based, Simple shogi(japanese chess) program.
 * Copyright (C) 2002 Masahiko Tokita
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * DTe class
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/dte.h,v $
 * $Id: dte.h,v 1.1.1.1 2005/12/09 09:03:04 tokita Exp $
 */

#ifndef _DTE_H_
#define _DTE_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


typedef struct {
  /** ưξ */
  int to;
  /** ưξ */
  int fm;
  /** ʤ 1 ʳ 0 򥻥åȤ */
  int nari;
  /** ǤʤǤ ʳ 0 򥻥åȤ */
  int uti;
} DTe;

/*********************************************************/
/* function prototypes */
/*********************************************************/

DTe* daemon_dte_new   (void);
void daemon_dte_free  (DTe* te);
void daemon_dte_output(DTe* te,
		       FILE* out);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _DTE_H_ */
