/*
 * Daemonshogi -- a GTK+ based, Simple shogi(japanese chess) program.
 * Copyright (C) 2002 Masahiko Tokita
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/**
 * FileReader class
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/filereader.h,v $
 * $Id: filereader.h,v 1.1.1.1 2005/12/09 09:03:04 tokita Exp $
 */

#ifndef _FILE_READER_H_
#define _FILE_READER_H_

#include <iconv.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/** Ԥκʸ */
#define FILEREADER_MAXCOLUMN 120

typedef enum {
  D_FILEREADER_STAT_SUCCESSFUL,
  D_FILEREADER_STAT_ERROR,
} D_FILEREADER_STAT;

/**
 * ƥȥեɤ߹Ԥʤݥ饹
 * ʸѴԤʤǥեȤ SJIS Ϥ EUC-JP
 *  120 ʸ1500 Ԥޤɤ߹
 */
typedef struct {
  /** ʸ */
  char incode[32];
  /** ʸ */
  char outcode[32];
  /** ɤ߹ե FILE ¤ΤؤΥݥ */
  FILE *in;
  /** ɤ߹ե */
  char *filename;
  /** եɤ߹߾ */
  D_FILEREADER_STAT stat;
  /** iconv ǻȤǥץ */
  iconv_t cd;
  /** push 줿ʸ󤬤뤫Υե饰 */
  int pushed;
  /** push 줿ʸ */
  char pushed_string[FILEREADER_MAXCOLUMN];
  /** buffer */
  char buf[BUFSIZ *2];
} FileReader;

FileReader*       daemon_filereader_new         (void);
void              daemon_filereader_init        (FileReader* reader);
void              daemon_filereader_free        (FileReader* reader);
int               daemon_filereader_open        (FileReader* reader,
						 char *filename);
void              daemon_filereader_close       (FileReader* reader);
char*             daemon_filereader_next        (FileReader* reader);
void              daemon_filereader_set_incode  (FileReader* reader,
						 char *incode);
void              daemon_filereader_set_outcode (FileReader* reader,
						 char *outcode);
char*             daemon_filereader_skip_space  (char *s);
char*             daemon_filereader_skip_comment(FileReader* reader, char c);
void              daemon_filereader_push        (FileReader* reader, char *s);
void              daemon_filereader_return2zero (char *s);
D_FILEREADER_STAT daemon_filereader_get_stat    (FileReader* reader);

#ifdef __cplusplus
}
#endif /* __cplusplus */


#endif /* _FILE_READER_H_ */
