/*
 * Խػ! - ΥեGladeˤäƤޤ.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>

#include <gnome.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

static GnomeUIInfo menufile_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_OPEN_ITEM (on_fileopen_activate, NULL),
  GNOMEUIINFO_MENU_SAVE_ITEM (on_filesave_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  GNOMEUIINFO_MENU_EXIT_ITEM (on_exit_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo game_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("playgame"),
    NULL,
    (gpointer) on_new_game_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("retract"),
    NULL,
    (gpointer) on_matta_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("give up"),
    NULL,
    (gpointer) on_giveup_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("stop"),
    NULL,
    (gpointer) on_stop_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("restart"),
    NULL,
    (gpointer) on_restart_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("check mate"),
    NULL,
    (gpointer) on_check_mate_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo menu_icon_and_text_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("icon & text"),
    NULL,
    (gpointer) on_menu_icon_and_text_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("icon"),
    NULL,
    (gpointer) on_menu_icon_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("text"),
    NULL,
    (gpointer) on_menu_text_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("none"),
    NULL,
    (gpointer) on_toolbarhide_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo toolbar_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_RADIOITEMS, NULL, NULL, menu_icon_and_text_uiinfo,
    NULL, NULL, GNOME_APP_PIXMAP_NONE, NULL, 0,
    (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo small_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("small"),
    NULL,
    (gpointer) on_small_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("middle"),
    NULL,
    (gpointer) on_middle_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("big"),
    NULL,
    (gpointer) on_big_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo view_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_RADIOITEMS, NULL, NULL, small_uiinfo,
    NULL, NULL, GNOME_APP_PIXMAP_NONE, NULL, 0,
    (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("flip"),
    NULL,
    (gpointer) on_flip_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_TOGGLEITEM, N_("book window"),
    NULL,
    (gpointer) on_bookwindow_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_SUBTREE, N_("toolbar"),
    NULL,
    toolbar_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_TOGGLEITEM, N_("statusbar"),
    NULL,
    (gpointer) on_statusbar_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo book_menu_uiinfo[] =
{
  {
    GNOME_APP_UI_ITEM, N_("first"),
    NULL,
    (gpointer) on_first_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("back"),
    NULL,
    (gpointer) on_back_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("next"),
    NULL,
    (gpointer) on_next_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("last"),
    NULL,
    (gpointer) on_last_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo edit_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_NEW_ITEM (N_("startedit"), NULL, on_startedit_activate, NULL),
  GNOMEUIINFO_SEPARATOR,
  {
    GNOME_APP_UI_ITEM, N_("set hirate"),
    NULL,
    (gpointer) on_set_hirate_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("set mate"),
    NULL,
    (gpointer) on_set_mate_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("right/left reversal"),
    NULL,
    (gpointer) on_rl_reversal_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("order reversal"),
    NULL,
    (gpointer) on_order_reversal_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("flip"),
    NULL,
    (gpointer) on_edit_flip_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  {
    GNOME_APP_UI_ITEM, N_("all koma to piecebox"),
    NULL,
    (gpointer) on_all_koma_to_pbox_activate, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_END
};

static GnomeUIInfo help_menu_uiinfo[] =
{
  GNOMEUIINFO_MENU_ABOUT_ITEM (on_about_activate, NULL),
  GNOMEUIINFO_END
};

static GnomeUIInfo menubar_uiinfo[] =
{
  GNOMEUIINFO_MENU_FILE_TREE (menufile_menu_uiinfo),
  {
    GNOME_APP_UI_SUBTREE, N_("_game"),
    NULL,
    game_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_MENU_VIEW_TREE (view_menu_uiinfo),
  {
    GNOME_APP_UI_SUBTREE, N_("_book"),
    NULL,
    book_menu_uiinfo, NULL, NULL,
    GNOME_APP_PIXMAP_NONE, NULL,
    0, (GdkModifierType) 0, NULL
  },
  GNOMEUIINFO_MENU_EDIT_TREE (edit_menu_uiinfo),
  GNOMEUIINFO_MENU_HELP_TREE (help_menu_uiinfo),
  GNOMEUIINFO_END
};

GtkWidget*
create_window (void)
{
  GtkWidget *window;
  GtkWidget *vbox1;
  GtkWidget *handlebox_menu;
  GtkWidget *menubar;
  GtkWidget *handlebox_toolbar;
  GtkWidget *toolbar;
  GtkWidget *tmp_toolbar_icon;
  GtkWidget *button_new_game;
  GtkWidget *button_stop;
  GtkWidget *button_give_up;
  GtkWidget *button_first;
  GtkWidget *button_back;
  GtkWidget *button_next;
  GtkWidget *button_last;
  GtkWidget *drawingarea;
  GtkWidget *statusbar;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (window), "window", window);
  GTK_WIDGET_SET_FLAGS (window, GTK_CAN_DEFAULT);
  gtk_window_set_title (GTK_WINDOW (window), _("daemonshogi"));
  gtk_window_set_policy (GTK_WINDOW (window), FALSE, FALSE, TRUE);

  vbox1 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox1);
  gtk_object_set_data_full (GTK_OBJECT (window), "vbox1", vbox1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox1);
  gtk_container_add (GTK_CONTAINER (window), vbox1);
  gtk_widget_set_usize (vbox1, 0, 0);

  handlebox_menu = gtk_handle_box_new ();
  gtk_widget_ref (handlebox_menu);
  gtk_object_set_data_full (GTK_OBJECT (window), "handlebox_menu", handlebox_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox_menu);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox_menu, TRUE, TRUE, 0);
  gtk_widget_set_usize (handlebox_menu, -2, 0);

  menubar = gtk_menu_bar_new ();
  gtk_widget_ref (menubar);
  gtk_object_set_data_full (GTK_OBJECT (window), "menubar", menubar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (menubar);
  gtk_container_add (GTK_CONTAINER (handlebox_menu), menubar);
  gnome_app_fill_menu (GTK_MENU_SHELL (menubar), menubar_uiinfo,
                       NULL, FALSE, 0);

  gtk_widget_ref (menubar_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "menufile",
                            menubar_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menufile_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "fileopen",
                            menufile_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menufile_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "filesave",
                            menufile_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menufile_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "separator1",
                            menufile_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menufile_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "exit",
                            menufile_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "game",
                            menubar_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "playgame",
                            game_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "separator2",
                            game_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "retract",
                            game_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "give_up",
                            game_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "stop",
                            game_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "restart",
                            game_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "__________2",
                            game_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (game_menu_uiinfo[7].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "check_mate",
                            game_menu_uiinfo[7].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "view",
                            menubar_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (small_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "small",
                            small_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (small_uiinfo[0].widget), TRUE);

  gtk_widget_ref (small_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "middle",
                            small_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (small_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "big",
                            small_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "separator4",
                            view_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "flip",
                            view_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "__________3",
                            view_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "bookwindow",
                            view_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "separator5",
                            view_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "toolbar",
                            view_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu_icon_and_text_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "menu_icon_and_text",
                            menu_icon_and_text_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (menu_icon_and_text_uiinfo[0].widget), TRUE);

  gtk_widget_ref (menu_icon_and_text_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "menu_icon",
                            menu_icon_and_text_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu_icon_and_text_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "menu_text",
                            menu_icon_and_text_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menu_icon_and_text_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "toolbarhide",
                            menu_icon_and_text_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[7].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "__________1",
                            view_menu_uiinfo[7].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (view_menu_uiinfo[8].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "statusbar",
                            view_menu_uiinfo[8].widget,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_check_menu_item_set_active (GTK_CHECK_MENU_ITEM (view_menu_uiinfo[8].widget), TRUE);

  gtk_widget_ref (menubar_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "book",
                            menubar_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (book_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "first",
                            book_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (book_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "back",
                            book_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (book_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "next",
                            book_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (book_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "last",
                            book_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "edit",
                            menubar_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "startedit",
                            edit_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[1].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "separator3",
                            edit_menu_uiinfo[1].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[2].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "set_hirate",
                            edit_menu_uiinfo[2].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[3].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "set_mate",
                            edit_menu_uiinfo[3].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[4].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "rl_reversal",
                            edit_menu_uiinfo[4].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "order_reversal",
                            edit_menu_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[6].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "edit_flip",
                            edit_menu_uiinfo[6].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (edit_menu_uiinfo[7].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "all_koma_to_pbox",
                            edit_menu_uiinfo[7].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (menubar_uiinfo[5].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "help",
                            menubar_uiinfo[5].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_widget_ref (help_menu_uiinfo[0].widget);
  gtk_object_set_data_full (GTK_OBJECT (window), "about",
                            help_menu_uiinfo[0].widget,
                            (GtkDestroyNotify) gtk_widget_unref);

  handlebox_toolbar = gtk_handle_box_new ();
  gtk_widget_ref (handlebox_toolbar);
  gtk_object_set_data_full (GTK_OBJECT (window), "handlebox_toolbar", handlebox_toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (handlebox_toolbar);
  gtk_box_pack_start (GTK_BOX (vbox1), handlebox_toolbar, TRUE, TRUE, 0);

  toolbar = gtk_toolbar_new (GTK_ORIENTATION_HORIZONTAL, GTK_TOOLBAR_BOTH);
  gtk_widget_ref (toolbar);
  gtk_object_set_data_full (GTK_OBJECT (window), "toolbar", toolbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (toolbar);
  gtk_container_add (GTK_CONTAINER (handlebox_toolbar), toolbar);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_NEW);
  button_new_game = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("new game"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_new_game);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_new_game", button_new_game,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_new_game);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_STOP);
  button_stop = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("stop"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_stop);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_stop", button_stop,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_stop);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_EXIT);
  button_give_up = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("give up"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_give_up);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_give_up", button_give_up,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_give_up);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_FIRST);
  button_first = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("first"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_first);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_first", button_first,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_first);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_BACK);
  button_back = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("back"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_back);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_back", button_back,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_back);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_FORWARD);
  button_next = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("next"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_next);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_next", button_next,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_next);

  tmp_toolbar_icon = gnome_stock_pixmap_widget (window, GNOME_STOCK_PIXMAP_LAST);
  button_last = gtk_toolbar_append_element (GTK_TOOLBAR (toolbar),
                                GTK_TOOLBAR_CHILD_BUTTON,
                                NULL,
                                _("last"),
                                NULL, NULL,
                                tmp_toolbar_icon, NULL, NULL);
  gtk_widget_ref (button_last);
  gtk_object_set_data_full (GTK_OBJECT (window), "button_last", button_last,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_last);

  drawingarea = gtk_drawing_area_new ();
  gtk_widget_ref (drawingarea);
  gtk_object_set_data_full (GTK_OBJECT (window), "drawingarea", drawingarea,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (drawingarea);
  gtk_box_pack_start (GTK_BOX (vbox1), drawingarea, TRUE, TRUE, 0);
  gtk_widget_set_usize (drawingarea, 640, 380);
  gtk_widget_set_events (drawingarea, GDK_EXPOSURE_MASK | GDK_POINTER_MOTION_MASK | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_LEAVE_NOTIFY_MASK);

  statusbar = gtk_statusbar_new ();
  gtk_widget_ref (statusbar);
  gtk_object_set_data_full (GTK_OBJECT (window), "statusbar", statusbar,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (statusbar);
  gtk_box_pack_start (GTK_BOX (vbox1), statusbar, FALSE, FALSE, 0);

  gtk_signal_connect (GTK_OBJECT (window), "destroy_event",
                      GTK_SIGNAL_FUNC (on_window_destroy_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (window), "destroy",
                      GTK_SIGNAL_FUNC (on_window_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_new_game), "pressed",
                      GTK_SIGNAL_FUNC (on_new_game_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_stop), "pressed",
                      GTK_SIGNAL_FUNC (on_stop_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_give_up), "pressed",
                      GTK_SIGNAL_FUNC (on_give_up_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_first), "pressed",
                      GTK_SIGNAL_FUNC (on_first_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_back), "pressed",
                      GTK_SIGNAL_FUNC (on_back_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_next), "pressed",
                      GTK_SIGNAL_FUNC (on_next_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_last), "pressed",
                      GTK_SIGNAL_FUNC (on_last_activate),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea), "motion_notify_event",
                      GTK_SIGNAL_FUNC (on_drawingarea_motion_notify_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea), "button_press_event",
                      GTK_SIGNAL_FUNC (on_drawingarea_button_press_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea), "button_release_event",
                      GTK_SIGNAL_FUNC (on_drawingarea_button_release_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea), "expose_event",
                      GTK_SIGNAL_FUNC (on_drawingarea_expose_event),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (drawingarea), "leave_notify_event",
                      GTK_SIGNAL_FUNC (on_drawingarea_leave_notify_event),
                      NULL);

  gtk_widget_grab_default (window);
  return window;
}

GtkWidget*
create_fileselection (void)
{
  GtkWidget *fileselection;
  GtkWidget *ok_button;
  GtkWidget *cancel_button;

  fileselection = gtk_file_selection_new (_("fileselection"));
  gtk_object_set_data (GTK_OBJECT (fileselection), "fileselection", fileselection);
  gtk_container_set_border_width (GTK_CONTAINER (fileselection), 10);

  ok_button = GTK_FILE_SELECTION (fileselection)->ok_button;
  gtk_object_set_data (GTK_OBJECT (fileselection), "ok_button", ok_button);
  gtk_widget_show (ok_button);
  GTK_WIDGET_SET_FLAGS (ok_button, GTK_CAN_DEFAULT);

  cancel_button = GTK_FILE_SELECTION (fileselection)->cancel_button;
  gtk_object_set_data (GTK_OBJECT (fileselection), "cancel_button", cancel_button);
  gtk_widget_show (cancel_button);
  GTK_WIDGET_SET_FLAGS (cancel_button, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (ok_button), "pressed",
                      GTK_SIGNAL_FUNC (on_ok_button_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (cancel_button), "pressed",
                      GTK_SIGNAL_FUNC (on_cancel_button_pressed),
                      NULL);

  return fileselection;
}

GtkWidget*
create_about (void)
{
  const gchar *authors[] = {
    NULL
  };
  GtkWidget *about;

  about = gnome_about_new ("daemonshogi", VERSION,
                        _("Masahiko Tokita<BQB04357@nifty.ne.jp>"),
                        authors,
                        _("Very simple shogi(japanese chess) game."),
                        "daemonshogi/daemon.xpm");
  gtk_object_set_data (GTK_OBJECT (about), "about", about);
  gtk_window_set_modal (GTK_WINDOW (about), TRUE);

  return about;
}

GtkWidget*
create_bookwindow (void)
{
  GtkWidget *bookwindow;
  GtkWidget *vbox2;
  GtkWidget *scrolledwindow;
  GtkWidget *viewport1;
  GtkWidget *booklist;

  bookwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (bookwindow), "bookwindow", bookwindow);
  gtk_window_set_title (GTK_WINDOW (bookwindow), _("bookwindow"));

  vbox2 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox2);
  gtk_object_set_data_full (GTK_OBJECT (bookwindow), "vbox2", vbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox2);
  gtk_container_add (GTK_CONTAINER (bookwindow), vbox2);

  scrolledwindow = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow);
  gtk_object_set_data_full (GTK_OBJECT (bookwindow), "scrolledwindow", scrolledwindow,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow);
  gtk_box_pack_start (GTK_BOX (vbox2), scrolledwindow, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow, 200, 200);

  viewport1 = gtk_viewport_new (NULL, NULL);
  gtk_widget_ref (viewport1);
  gtk_object_set_data_full (GTK_OBJECT (bookwindow), "viewport1", viewport1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (viewport1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow), viewport1);

  booklist = gtk_list_new ();
  gtk_widget_ref (booklist);
  gtk_object_set_data_full (GTK_OBJECT (bookwindow), "booklist", booklist,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (booklist);
  gtk_container_add (GTK_CONTAINER (viewport1), booklist);

  gtk_signal_connect (GTK_OBJECT (bookwindow), "destroy",
                      GTK_SIGNAL_FUNC (on_bookwindow_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (booklist), "button_press_event",
                      GTK_SIGNAL_FUNC (on_booklist_button_press_event),
                      NULL);

  return bookwindow;
}

GtkWidget*
create_dialog_mate (void)
{
  GtkWidget *dialog_mate;
  GtkWidget *dialog_vbox1;
  GtkWidget *vbox3;
  GtkWidget *label_mate;
  GtkWidget *frame;
  GtkWidget *vbox4;
  GSList *vbox4_group = NULL;
  GtkWidget *radiobutton_mate_sente;
  GtkWidget *radiobutton_mate_gote;
  GtkWidget *dialog_action_area1;
  GtkWidget *button_mate_start;
  GtkWidget *button_mate_cancel;

  dialog_mate = gnome_dialog_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (dialog_mate), "dialog_mate", dialog_mate);
  gtk_window_set_modal (GTK_WINDOW (dialog_mate), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_mate), FALSE, FALSE, FALSE);

  dialog_vbox1 = GNOME_DIALOG (dialog_mate)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_mate), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  vbox3 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox3);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "vbox3", vbox3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox3);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), vbox3, TRUE, TRUE, 0);

  label_mate = gtk_label_new (_("check mate"));
  gtk_widget_ref (label_mate);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "label_mate", label_mate,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label_mate);
  gtk_box_pack_start (GTK_BOX (vbox3), label_mate, FALSE, FALSE, 0);
  gtk_label_set_justify (GTK_LABEL (label_mate), GTK_JUSTIFY_LEFT);

  frame = gtk_frame_new (NULL);
  gtk_widget_ref (frame);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "frame", frame,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame);
  gtk_box_pack_start (GTK_BOX (vbox3), frame, TRUE, TRUE, 0);

  vbox4 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox4);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "vbox4", vbox4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox4);
  gtk_container_add (GTK_CONTAINER (frame), vbox4);

  radiobutton_mate_sente = gtk_radio_button_new_with_label (vbox4_group, _("sente(white)"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_mate_sente));
  gtk_widget_ref (radiobutton_mate_sente);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "radiobutton_mate_sente", radiobutton_mate_sente,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_mate_sente);
  gtk_box_pack_start (GTK_BOX (vbox4), radiobutton_mate_sente, FALSE, FALSE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton_mate_sente), TRUE);

  radiobutton_mate_gote = gtk_radio_button_new_with_label (vbox4_group, _("gote(black)"));
  vbox4_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton_mate_gote));
  gtk_widget_ref (radiobutton_mate_gote);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "radiobutton_mate_gote", radiobutton_mate_gote,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton_mate_gote);
  gtk_box_pack_start (GTK_BOX (vbox4), radiobutton_mate_gote, FALSE, FALSE, 0);

  dialog_action_area1 = GNOME_DIALOG (dialog_mate)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_mate), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area1), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area1), 8);

  gnome_dialog_append_button_with_pixmap (GNOME_DIALOG (dialog_mate),
                                          _("Anser start"), GNOME_STOCK_PIXMAP_FORWARD);
  button_mate_start = GTK_WIDGET (g_list_last (GNOME_DIALOG (dialog_mate)->buttons)->data);
  gtk_widget_ref (button_mate_start);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "button_mate_start", button_mate_start,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_mate_start);
  GTK_WIDGET_SET_FLAGS (button_mate_start, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (dialog_mate), GNOME_STOCK_BUTTON_CANCEL);
  button_mate_cancel = GTK_WIDGET (g_list_last (GNOME_DIALOG (dialog_mate)->buttons)->data);
  gtk_widget_ref (button_mate_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog_mate), "button_mate_cancel", button_mate_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_mate_cancel);
  GTK_WIDGET_SET_FLAGS (button_mate_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (button_mate_start), "pressed",
                      GTK_SIGNAL_FUNC (on_button_mate_start_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_mate_cancel), "pressed",
                      GTK_SIGNAL_FUNC (on_button_mate_cancel_pressed),
                      NULL);

  return dialog_mate;
}

GtkWidget*
create_thinking_messagebox (void)
{
  GtkWidget *thinking_messagebox;
  GtkWidget *dialog_vbox2;
  GtkWidget *button;
  GtkWidget *dialog_action_area2;

  /* We create it with an OK button, and then remove the button, to work
     around a bug in gnome-libs. */
  thinking_messagebox = gnome_message_box_new (_("Now thiking..."),
                              GNOME_MESSAGE_BOX_INFO,
                              GNOME_STOCK_BUTTON_OK, NULL);
  gtk_container_remove (GTK_CONTAINER (GNOME_DIALOG (thinking_messagebox)->action_area), GNOME_DIALOG (thinking_messagebox)->buttons->data);
  GNOME_DIALOG (thinking_messagebox)->buttons = NULL;
  gtk_object_set_data (GTK_OBJECT (thinking_messagebox), "thinking_messagebox", thinking_messagebox);
  gtk_window_set_title (GTK_WINDOW (thinking_messagebox), _("information"));
  gtk_window_set_modal (GTK_WINDOW (thinking_messagebox), TRUE);
  gtk_window_set_policy (GTK_WINDOW (thinking_messagebox), FALSE, FALSE, FALSE);

  dialog_vbox2 = GNOME_DIALOG (thinking_messagebox)->vbox;
  gtk_object_set_data (GTK_OBJECT (thinking_messagebox), "dialog_vbox2", dialog_vbox2);
  gtk_widget_show (dialog_vbox2);

  gnome_dialog_append_button (GNOME_DIALOG (thinking_messagebox), GNOME_STOCK_BUTTON_CANCEL);
  button = GTK_WIDGET (g_list_last (GNOME_DIALOG (thinking_messagebox)->buttons)->data);
  gtk_widget_ref (button);
  gtk_object_set_data_full (GTK_OBJECT (thinking_messagebox), "button", button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button);
  GTK_WIDGET_SET_FLAGS (button, GTK_CAN_DEFAULT);

  dialog_action_area2 = GNOME_DIALOG (thinking_messagebox)->action_area;
  gtk_widget_ref (dialog_action_area2);
  gtk_object_set_data_full (GTK_OBJECT (thinking_messagebox), "dialog_action_area2", dialog_action_area2,
                            (GtkDestroyNotify) gtk_widget_unref);

  gtk_signal_connect (GTK_OBJECT (button), "pressed",
                      GTK_SIGNAL_FUNC (on_mate_thik_cancel),
                      NULL);

  return thinking_messagebox;
}

GtkWidget*
create_dialog_game (void)
{
  GtkWidget *dialog_game;
  GtkWidget *dialog_vbox3;
  GtkWidget *vbox5;
  GtkWidget *table1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *optionmenu_sente;
  GtkWidget *optionmenu_sente_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *optionmenu_gote;
  GtkWidget *optionmenu_gote_menu;
  GtkWidget *entry_sente;
  GtkWidget *entry_gote;
  GtkWidget *frame1;
  GtkWidget *optionmenu_teai;
  GtkWidget *optionmenu_teai_menu;
  GtkWidget *dialog_action_area3;
  GtkWidget *button_game_ok;
  GtkWidget *button_game_cancel;

  dialog_game = gnome_dialog_new (NULL, NULL);
  gtk_object_set_data (GTK_OBJECT (dialog_game), "dialog_game", dialog_game);
  gtk_window_set_modal (GTK_WINDOW (dialog_game), TRUE);
  gtk_window_set_policy (GTK_WINDOW (dialog_game), FALSE, FALSE, FALSE);

  dialog_vbox3 = GNOME_DIALOG (dialog_game)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog_game), "dialog_vbox3", dialog_vbox3);
  gtk_widget_show (dialog_vbox3);

  vbox5 = gtk_vbox_new (FALSE, 0);
  gtk_widget_ref (vbox5);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "vbox5", vbox5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox5);
  gtk_box_pack_start (GTK_BOX (dialog_vbox3), vbox5, TRUE, TRUE, 0);

  table1 = gtk_table_new (3, 2, FALSE);
  gtk_widget_ref (table1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "table1", table1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table1);
  gtk_box_pack_start (GTK_BOX (vbox5), table1, TRUE, TRUE, 0);

  label1 = gtk_label_new (_("SENTE(WHITE)"));
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_table_attach (GTK_TABLE (table1), label1, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label1), 0, 0.5);

  label2 = gtk_label_new (_("GOTE(BLACK)"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_table_attach (GTK_TABLE (table1), label2, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (label2), 0, 0.5);

  optionmenu_sente = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_sente);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "optionmenu_sente", optionmenu_sente,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_sente);
  gtk_table_attach (GTK_TABLE (table1), optionmenu_sente, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  optionmenu_sente_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("HUMAN"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL1"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL2"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL3"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("SERIALPORT1"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("SERIALPORT2"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_sente_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_sente), optionmenu_sente_menu);

  optionmenu_gote = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_gote);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "optionmenu_gote", optionmenu_gote,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_gote);
  gtk_table_attach (GTK_TABLE (table1), optionmenu_gote, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  optionmenu_gote_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("HUMAN"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL1"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL2"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("LEVEL3"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("SERIALPORT1"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("SERIALPORT2"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_gote_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_gote), optionmenu_gote_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (optionmenu_gote), 1);

  entry_sente = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (entry_sente);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "entry_sente", entry_sente,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_sente);
  gtk_table_attach (GTK_TABLE (table1), entry_sente, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  entry_gote = gtk_entry_new_with_max_length (32);
  gtk_widget_ref (entry_gote);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "entry_gote", entry_gote,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_gote);
  gtk_table_attach (GTK_TABLE (table1), entry_gote, 1, 2, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);

  frame1 = gtk_frame_new (_("HANDICAP"));
  gtk_widget_ref (frame1);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "frame1", frame1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame1);
  gtk_box_pack_start (GTK_BOX (vbox5), frame1, TRUE, TRUE, 0);

  optionmenu_teai = gtk_option_menu_new ();
  gtk_widget_ref (optionmenu_teai);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "optionmenu_teai", optionmenu_teai,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (optionmenu_teai);
  gtk_container_add (GTK_CONTAINER (frame1), optionmenu_teai);
  optionmenu_teai_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("HIRATE"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_teai_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("NIMAIOTI"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_teai_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("YONMAIOTI"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_teai_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("ETC"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (optionmenu_teai_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (optionmenu_teai), optionmenu_teai_menu);

  dialog_action_area3 = GNOME_DIALOG (dialog_game)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog_game), "dialog_action_area3", dialog_action_area3);
  gtk_widget_show (dialog_action_area3);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (dialog_action_area3), GTK_BUTTONBOX_END);
  gtk_button_box_set_spacing (GTK_BUTTON_BOX (dialog_action_area3), 8);

  gnome_dialog_append_button (GNOME_DIALOG (dialog_game), GNOME_STOCK_BUTTON_OK);
  button_game_ok = GTK_WIDGET (g_list_last (GNOME_DIALOG (dialog_game)->buttons)->data);
  gtk_widget_ref (button_game_ok);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "button_game_ok", button_game_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_game_ok);
  GTK_WIDGET_SET_FLAGS (button_game_ok, GTK_CAN_DEFAULT);

  gnome_dialog_append_button (GNOME_DIALOG (dialog_game), GNOME_STOCK_BUTTON_CANCEL);
  button_game_cancel = GTK_WIDGET (g_list_last (GNOME_DIALOG (dialog_game)->buttons)->data);
  gtk_widget_ref (button_game_cancel);
  gtk_object_set_data_full (GTK_OBJECT (dialog_game), "button_game_cancel", button_game_cancel,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button_game_cancel);
  GTK_WIDGET_SET_FLAGS (button_game_cancel, GTK_CAN_DEFAULT);

  gtk_signal_connect (GTK_OBJECT (optionmenu_sente), "pressed",
                      GTK_SIGNAL_FUNC (on_game_optionmenu_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (optionmenu_gote), "pressed",
                      GTK_SIGNAL_FUNC (on_game_optionmenu_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (optionmenu_teai), "pressed",
                      GTK_SIGNAL_FUNC (on_game_optionmenu_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_game_ok), "pressed",
                      GTK_SIGNAL_FUNC (on_button_game_ok_pressed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (button_game_cancel), "pressed",
                      GTK_SIGNAL_FUNC (on_button_game_cancel_pressed),
                      NULL);

  return dialog_game;
}

GtkWidget*
create_logo_window (void)
{
  GtkWidget *logo_window;
  gchar *pixmap1_filename;
  GtkWidget *pixmap1;

  logo_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_object_set_data (GTK_OBJECT (logo_window), "logo_window", logo_window);
  gtk_window_set_title (GTK_WINDOW (logo_window), _("daemonshogi"));
  gtk_window_set_modal (GTK_WINDOW (logo_window), TRUE);
  gtk_window_set_policy (GTK_WINDOW (logo_window), FALSE, FALSE, TRUE);

  pixmap1 = gtk_type_new (gnome_pixmap_get_type ());
  pixmap1_filename = gnome_pixmap_file ("daemonshogi/daemon2.xpm");
  if (pixmap1_filename)
    gnome_pixmap_load_file (GNOME_PIXMAP (pixmap1), pixmap1_filename);
  else
    g_warning (_("Couldn't find pixmap file: %s"), "daemon2.xpm");
  g_free (pixmap1_filename);
  gtk_widget_ref (pixmap1);
  gtk_object_set_data_full (GTK_OBJECT (logo_window), "pixmap1", pixmap1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap1);
  gtk_container_add (GTK_CONTAINER (logo_window), pixmap1);

  return logo_window;
}

