/* SI SHOGI Library
   Copyright (C) 2002 Masahiko Tokita
   This file is part of the SI SHOGI Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.w

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with The Daemonshogi; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */
/*
 * grade.c
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/si/grade.c,v $
 * $Id: grade.c,v 1.1.1.1 2005/12/09 09:03:08 tokita Exp $
 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include "si.h"
#include "ui.h"

/**
 * ⤬˿ʤȤ˥ݥ󥿤û뤫Υե饰
 * Ƥû롣
 */
#undef USE_ADD_FU_ADVANCE_POINT

/**
 * ˡ֤Ͼ˹ԤݥȤ򸺤餹Υե饰
 * Ƥ鸺餹
 */
#undef USE_DEC_KEI_KYO_POINT

/**
 * ̤ζμ֡οɾ׻֤
 * @param bo оݤBOARD
 * @param next ׻
 * @return ɾ
 */
int grade(BOARD *bo, int next) {
  MOVEINFO *mi;
  int point, p, piece_p, n;
  int king_xy, kx, ky;
  int jx, jy;
  int x, y;
  int v, w;
  int i;
  extern const int arr_point[];
  extern const int arr_piece[];
  extern const int arr_xy[];
  extern const int arr_point_xy[17][9];
  extern const int arr_point_xy2[17][9];

#ifdef DEBUG
  assert( bo != NULL );
  assert( next == 0 || next == 1 );
#endif /* DEBUG */

  /* ̤ΰ */
  king_xy = bo->code_xy[1 + next][0];
  kx = king_xy & 0xF;
  ky = king_xy >> 4;

  /* ̤ΰ */
  king_xy = bo->code_xy[1 + (next==0)][0];
  jx = king_xy & 0xF;
  jy = king_xy >> 4;

  point = 0;

  for (i = 1; i <= 81; i++) {
    p = boGetPiece(bo, arr_xy[ i ]);
    if ( p == 0 || getTeban( p ) != next || p == OH || p == (OH | 0x10))
      continue;
    
    n = boGetNoBoard(bo, arr_xy[ i ]);

    piece_p = arr_point[ p ];
    point += piece_p;
    /* printf("%02X : %d\n", p, piece_p); */

    x = arr_xy[ i ] & 0xF;
    y = arr_xy[ i ] >> 4;

    /* ϾعԤݥȤ⤤ */
#ifdef USE_ADD_FU_ADVANCE_POINT
    if ( (p & 0xF) == FU ) {
      if ( next == SENTE ) {
	bo->point[ SENTE ] += (10-y) * FU_POSITION_POINT;
      } else {
	bo->point[ GOTE ] += y * FU_POSITION_POINT;
      }
    }
#endif /* USE_ADD_FU_ADVANCE_POINT */
#ifdef USE_DEC_KEI_KYO_POINT
    if ( (p & 0xF) == KYO ) {
      /* ֤Ͼư򸺤餹 */
      if ( next == SENTE ) {
	point -= (10-y) * 10;
      } else {
	point -= y * 10;
      }
    } else if ( (p & 0xF) == KEI ) {
      /* ϤϾư򸺤餹 */
      if ( next == SENTE ) {
	point -= (10-y) * 10;
      } else {
	point -= y * 10;
      }
    }
#endif /* USE_DEC_KEI_KYO_POINT */

    /* ֡Ѥξϰ֤ˤݥϤʤ */
    /* if ( ((p & HISYA) != HISYA) || ((p & KAKU) == KAKU) ) { */
    if ( ((p & 0xF) != HISYA) && ((p & 0xF) == KAKU) ) {
      v = abs(kx - x);
      if ( next == SENTE )
	w = ky - y;
      else 
	w = y - ky;
      
      /* point += arr_point_xy2[ 8 - w ][ v ]; */
      point += piece_p * ( arr_point_xy2[ 8 - w ][ v ] - 100 ) / MY_OH_DISTANCE_POINT;
    
      v = abs(jx - x);
      if ( next == SENTE )
	w = jy - y;
      else 
	w = y - jy;

      /* point += arr_point_xy[ 8 - w ][ v ]; */
      point += piece_p * ( arr_point_xy[ 8 - w ][ v ] - 100 ) / ONES_OH_DISTANCE_POINT;
    }

    if ( (p & 0xF) == HISYA && getTeban(p) == next ) {
      /* ֲ᤹ܶ٤餺פγʸ̤겦֤ᤤϸ */
      int hx, hy;

      hx = abs(kx - x);
      hy = abs(ky - y);
      if ( 4 < hx + hy ) {
	point -= ((hx + hy) * OH_HISYA_POINT);
      }
    }
    
    /* ưɾ˲ä */
    mi = boGetCodeTo(n);
    point += mi->count << NUM_OF_MOVE_POINT;
  }
  
  for (i = 1; i<=7; i++) {
    point += arr_piece[ i ] * bo->piece[ next ][ i ];
  }
  
  bo->point[ next ] = point;
  
  /* ΰ٤ɾ */
  add_oh_safe_grade(bo, next);

  return point;
}

/**
 * ɾ xy ΰ֤ζä롣
 * @param bo оݤBOARD
 * @param xy оݤζΰ
 * @param next ɾ
 */
void add_grade(BOARD *bo, int xy, int next ) {
  MOVEINFO *mi;
  int king_xy;
  int kx, ky;
  int jx, jy;
  int x, y;
  int v, w;
  int p, piece_p, n;
  extern const int arr_point[];
  extern const int arr_point_xy[17][9];
  extern const int arr_point_xy2[17][9];
  
#ifdef DEBUG
  assert( bo != NULL );
  assert( bo->board[xy] != 0 );
  assert( bo->board[xy] != WALL );
  assert( getTeban(bo->board[xy]) == next );
  assert( next == 0 || next == 1 );
#endif /* DEBUG */
  
  /* ̤ΰ */
  king_xy = bo->code_xy[1 + next][0];
  kx = king_xy & 0xF;
  ky = king_xy >> 4;
  
#ifdef DEBUG
  assert( bo->board[king_xy] == (0x08 + next * 0x10) );
#endif /* DEBUG */
  
  /* p = bo->board[ xy ]; */
  p = boGetPiece(bo, xy);
  if ( p == 0 || getTeban( p ) != next || p == OH || p == (OH | 0x10))
    return;
  
  n = boGetNoBoard(bo, xy);
  
  /* ̤ΰ */
  king_xy = bo->code_xy[1 + (next==0)][0];
  jx = king_xy & 0xF;
  jy = king_xy >> 4;

  x = xy & 0xF;
  y = xy >> 4;

  piece_p = arr_point[ p ];
  bo->point[ next ] += piece_p;

  /* ϾعԤݥȤ⤤ */
#ifdef USE_ADD_FU_ADVANCE_POINT
  if ( (p & 0xF) == FU ) {
    if ( next == SENTE ) {
      bo->point[ SENTE ] += (10-y) * FU_POSITION_POINT;
    } else {
      bo->point[ GOTE ] += y * FU_POSITION_POINT;
    }
  }
#endif /* USE_ADD_FU_ADVANCE_POINT */
#ifdef USE_DEC_KEI_KYO_POINT
  if ( (p & 0xF) == KYO ) {
    if ( next == SENTE ) {
      bo->point[ SENTE ] -= (10-y) * 5;
    } else {
      bo->point[ GOTE ] -= y * 5;
    }
  } else if ( (p & 0xF) == KEI ) {
    /* ϤϾư򸺤餹 */
    if ( next == SENTE ) {
      bo->point[ SENTE ] -= (10-y) * 5;
    } else {
      bo->point[ GOTE ] -= y * 5;
    }
  }
#endif /* USE_DEC_KEI_KYO_POINT */

  /* ֡Ѥξϰ֤ˤݥϤʤ */
  /* if ( ((p & HISYA) != HISYA) || ((p & KAKU) == KAKU) ) { */
  if ( ((p & 0xF) != HISYA) && ((p & 0xF) == KAKU) ) {
    v = abs(kx - x);
    if ( next == SENTE )
      w = ky - y;
    else 
      w = y - ky;

    /* bo->point[ next ] += arr_point_xy2[ 8 - w ][ v ]; */
    bo->point[ next ] += piece_p * ( arr_point_xy2[ 8 - w ][ v ] - 100 ) / MY_OH_DISTANCE_POINT;

    v = abs(jx - x);
    if ( next == SENTE )
      w = jy - y;
    else 
      w = y - jy;

    /* bo->point[ next ] += arr_point_xy[ 8 - w ][ v ]; */
    bo->point[ next ] += piece_p * ( arr_point_xy[ 8 - w ][ v ] - 100 ) / ONES_OH_DISTANCE_POINT;
  }
  
  if ( (p & 0xF) == HISYA && getTeban(p) == next ) {
    /* ֲ᤹ܶ٤餺פγʸ̤겦֤ᤤϸ */
    int hx, hy;
    
    hx = abs(kx - x);
    hy = abs(ky - y);
    if ( 4 < hx + hy ) {
      bo->point[ next ] -= ((hx + hy) * OH_HISYA_POINT);
    }
  }

  /* ưɾ˲ä */
  mi = boGetCodeTo(n);
  bo->point[ next ] += mi->count << NUM_OF_MOVE_POINT;
}

/**
 * ɾ xy ΰ֤ζ
 * @param bo оݤBOARD
 * @param xy оݤζΰ
 * @param next ɾ
 */
void sub_grade(BOARD *bo, int xy, int next ) {
  MOVEINFO *mi;
  int king_xy;
  int kx, ky;
  int jx, jy;
  int x, y;
  int v, w;
  int p, piece_p, n;
  extern const int arr_point[];
  extern const int arr_point_xy[17][9];
  extern const int arr_point_xy2[17][9];
  
#ifdef DEBUG
  assert( bo != NULL );
  assert( bo->board[xy] != 0 );
  assert( bo->board[xy] != WALL );
  assert( getTeban(bo->board[xy]) == next );
  assert( next == 0 || next == 1 );
#endif /* DEBUG */

  /* ̤ΰ */
  king_xy = bo->code_xy[1 + next][0];
  kx = king_xy & 0xF;
  ky = king_xy >> 4;
  
#ifdef DEBUG
  assert( bo->board[king_xy] == (0x08 + next * 0x10) );
#endif /* DEBUG */
  
  /* p = bo->board[ xy ]; */
  p = boGetPiece(bo, xy);
  if ( p == 0 || getTeban( p ) != next || p == OH || p == (OH | 0x10))
    return;
  
  n = boGetNoBoard(bo, xy);

  /* ̤ΰ */
  king_xy = bo->code_xy[1 + (next==0)][0];
  jx = king_xy & 0xF;
  jy = king_xy >> 4;

  x = xy & 0xF;
  y = xy >> 4;

  piece_p = arr_point[ p ];
  bo->point[ next ] -= piece_p;

  /* ϾعԤݥȤ⤤ */
#ifdef USE_ADD_FU_ADVANCE_POINT
  if ( (p & 0xF) == FU ) {
    if ( next == SENTE ) {
      bo->point[ SENTE ] -= (10-y) * FU_POSITION_POINT;
    } else {
      bo->point[ GOTE ] -= y * FU_POSITION_POINT;
    }
  }
#endif /* USE_ADD_FU_ADVANCE_POINT */
#ifdef USE_DEC_KEI_KYO_POINT
  if ( (p & 0xF) == KYO ) {
    if ( next == SENTE ) {
      bo->point[ SENTE ] += (10-y) * 5;
    } else {
      bo->point[ GOTE ] += y * 5;
    }
  } else if ( (p & 0xF) == KEI ) {
    /* ϤϾư򸺤餹 */
    if ( next == SENTE ) {
      bo->point[ SENTE ] += (10-y) * 5;
    } else {
      bo->point[ GOTE ] += y * 5;
    }
  }
#endif /* USE_DEC_KEI_KYO_POINT */

  /* ֡Ѥξϰ֤ˤݥϤʤ */
  /* if ( ((p & HISYA) != HISYA) || ((p & KAKU) == KAKU) ) { */
  if ( ((p & 0xF) != HISYA) && ((p & 0xF) == KAKU) ) {
    v = abs(kx - x);
    if ( next == SENTE )
      w = ky - y;
    else 
      w = y - ky;

    /* bo->point[ next ] -= arr_point_xy2[ 8 - w ][ v ]; */
    bo->point[ next ] -= piece_p * ( arr_point_xy2[ 8 - w ][ v ] - 100 ) / MY_OH_DISTANCE_POINT;

    v = abs(jx - x);
    if ( next == SENTE )
      w = jy - y;
    else 
      w = y - jy;

    /* bo->point[ next ] -= arr_point_xy[ 8 - w ][ v ]; */
    bo->point[ next ] -= piece_p * ( arr_point_xy[ 8 - w ][ v ] - 100 ) / ONES_OH_DISTANCE_POINT;
  }
  
  if ( (p & 0xF) == HISYA && getTeban(p) == next ) {
    /* ֲ᤹ܶ٤餺פγʸ̤겦֤ᤤϸ */
    int hx, hy;
    
    hx = abs(kx - x);
    hy = abs(ky - y);
    if ( 4 < hx + hy ) {
      bo->point[ next ] += ((hx + hy) * OH_HISYA_POINT);
    }
  }

  /* ưɾ˲ä */
  mi = boGetCodeTo(n);
  bo->point[ next ] -= mi->count << NUM_OF_MOVE_POINT;
}

/**
 * ɾ˼ä piece ä롣
 * @param bo оݤBOARD
 * @param piece ä
 * @param next ɾ
 */
void add_piece_grade(BOARD *bo, int piece, int next ) {
  extern const int arr_piece[];
  
#ifdef DEBUG
  assert( bo != NULL );
  assert( 1 <= piece && piece <=7 );
  assert( next == 0 || next == 1 );
#endif /* DEBUG */

  bo->point[ next ] += arr_piece[ piece ];
}

/**
 * ɾä piece 
 * @param bo оݤBOARD
 * @param piece ä
 * @param next ɾ
 */
void sub_piece_grade(BOARD *bo, int piece, int next ) {
  extern const int arr_piece[];
  
#ifdef DEBUG
  assert( bo != NULL );
  assert( 1 <= piece && piece <=7 );
  assert( next == 0 || next == 1 );
#endif /* DEBUG */

  bo->point[ next ] -= arr_piece[ piece ];
}

/**
 * μΰ٤ɾ롣
 * 
 * μ꣸ޥζθοߣޥʥ
 * ʬ֤ˤȤ˲ȶᤤϥޥʥ
 * 
 * @param bo 
 * @param next õ
 */
int oh_safe_grade(BOARD *bo, int king_xy, int next) {
  extern const int arr_round_to[8];
  int point;
  int i;

  point = 0;
  
  for ( i=0; i<8; i++ ) {
    point += boGetToBoardCount(king_xy + arr_round_to[ i ], next);
  }

  return point * OH_SAFE_POINT;
}

/**
 * ΰ٤ɾɾ­
 * @param bo оݤBOARD
 * @param next ɾ
 */
void add_oh_safe_grade(BOARD *bo, int next) {
  int king_xy;
  
  /* ̤ΰ */
  king_xy = bo->code_xy[1 + next][0];

  bo->point[ next ] += oh_safe_grade(bo, king_xy, (next == 0));
}

/**
 * ΰ٤ɾɾ 
 * @param bo оݤBOARD
 * @param next ɾ
 */
void sub_oh_safe_grade(BOARD *bo, int next) {
  int king_xy;
  
  /* ̤ΰ */
  king_xy = bo->code_xy[1 + next][0];

  bo->point[ next ] -= oh_safe_grade(bo, king_xy, (next == 0));
}

/**
 * ưɾͤ롣
 * @param bo оݤBOARD
 * @param xy ɾΰ
 * @param next ɾ
 */
void add_moving_grade(BOARD *bo, int xy, int next) {
  MOVEINFO *mi;
  int n;
  
  n = boGetNoBoard(bo, xy);
  mi = boGetCodeTo(n);
  bo->point[ next ] += mi->count << 3;
}

/**
 * ưɾͤ롣
 * @param bo оݤBOARD
 * @param xy ɾΰ
 * @param next ɾ
 */
void sub_moving_grade(BOARD *bo, int xy, int next) {
  MOVEINFO *mi;
  int n;
  
  n = boGetNoBoard(bo, xy);
  mi = boGetCodeTo(n);
  bo->point[ next ] -= mi->count << 3;
}
