/* SI SHOGI Library
   Copyright (C) 2002 Masahiko Tokita
   This file is part of the SI SHOGI Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.w

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with The Daemonshogi; if not, write to the Free
   Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
   02111-1307 USA.  */
/*
 * si.h
 * $Source: /cvsroot/daemonshogi/daemonshogi/src/si/si.h,v $
 * $Id: si.h,v 1.1.1.1 2005/12/09 09:03:10 tokita Exp $
 */

#ifndef _SI_H_
#define _SI_H_

#include <time.h>

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#ifndef VERSION
#define VERSION "0.0.2"
#endif /* VERSION */

#ifndef REVISION
#define REVISION "unknown"
#endif /* VERSION */

/** ˥ϥåȤϤΥե饰 */
#define USE_HASH 1
/** GUIΥʥϤΥե饰 */
#define USE_GUI 1
/** ꥢݡȤȤäжɤϤΥե饰 */
#define USE_SERIAL 1
/** Υե饰Ƥ ⡢ѡ 餺ϸʤ */
/* #define NOREC_NARAZU 1 */

#ifdef USE_SERIAL
#include "comaccess.h"
#endif /* USE_SERIAL */

#define WALL (0x20)

/** ǥեȤ» */
#define DEFAULT_LIMIT_TIME 1500

typedef enum {
  SENTE = 0,
  GOTE  = 1
} TEBAN;

/**  */
typedef enum {
  RYU     = 0x0F,
  UMA     = 0x0E,
  NARIGIN = 0x0C,
  NARIKEI = 0x0B,
  NARIKYO = 0x0A,
  TOKIN   = 0x09,
  OH      = 0x08,
  HISYA   = 0x07,
  KAKU    = 0x06,
  KIN     = 0x05,
  GIN     = 0x04,
  KEI     = 0x03,
  KYO     = 0x02,
  FU      = 0x01
} KOMATYPE;

/** ưκ */
#define toBoardCountMax 32

#ifndef DEBUG
/* ޥؿȤΥե饰ƤޥȤ */
#define USE_MISC_MACRO
#endif /* DEBUG */

#ifdef _MSC_VER
typedef __int64 si_int64;
#else
typedef long long si_int64;
#endif /* WIN32 */

/** mate() ֤ơ */
typedef enum {
  /** ͤߤ */
  CHECK_MATE = 1,
  /** Եͤ */
  NOT_CHECK_MATE = 0,
  /** (ϥå夫ǡФȤȤ) */
  UNKNOWN_CHECK_MATE = -1,
} MATESTATUS;

/**  */
typedef enum {
    /** ʿ */
  HIRATE,
  NIMAIOTI,
  YONMAIOTI,
  TEAI_ETC,
} TEAI;

/** si_input_next_* ֤Υơ */
typedef enum {
  /** ̾μ */
  SI_NORMAL = 0,
  /** ֤Υץ쥤䡼(꤬ȿ§ؤ) */
  SI_WIN = 1, 
  /** ֤Υץ쥤䡼λ */
  SI_TORYO = 2,
  /** ֤Υץ쥤䡼Ԥä */
  SI_MATTA = 3,
  /** ֤Υץ쥤䡼 */
  SI_CHUDAN = 4,
  /** ֤Υץ쥤䡼Ǥ */
  SI_CHUDAN_RECV = 5,
  /** ֤Υץ쥤䡼̤Ǿ */
  SI_KACHI = 6,
  /** ֤Υץ쥤䡼̤ǰʬ */
  SI_HIKIWAKE = 7,
  /** Ƥ꤬ʼä */
  SI_NGDATA = 8,
  /** ֤Υץ쥤䡼ڤ餱 */
  SI_TIMEOUT = 9
} INPUTSTATUS;

typedef enum {
  /** ʹ֤ˤ */
  SI_HUMAN = 0,
  /** ץ٥룱ˤ */
  SI_COMPUTER_1 = 1,
  /** ץ٥룲ˤ */
  SI_COMPUTER_2 = 2,
  /** ץ٥룳ˤ */
  SI_COMPUTER_3 = 3,
  /** ץ٥룴ˤ */
  SI_COMPUTER_4 = 4,
  /** ץ٥룵ˤ */
  SI_COMPUTER_5 = 5,
  /** ꥢݡȤϣ */
  SI_SERIALPORT_1 = 6,
  /** ꥢݡȤϣ */
  SI_SERIALPORT_2 = 7,
  /** ͥåȥϣ */
  SI_NETWORK_1 = 8,
  /** ͥåȥϣ */
  SI_NETWORK_2 = 9,
  /** GUIȤäʹ֤ˤ */
  SI_GUI_HUMAN = 10
} PLAYERTYPE;

/* ɾδ */
enum {
  /* ⤬˹ԤĻ */
  FU_POSITION_POINT = 10,
  /* ʬβؤεΥɾΨ餹⤯ʤ */
  MY_OH_DISTANCE_POINT = 200,
  /* βؤεΥɾΨ餹⤯ʤ */
  ONES_OH_DISTANCE_POINT = 100,
  /** 
   * μΰ٤
   * θ3 3  OH_SAFE_POINT ɾ麹
   */
  OH_SAFE_POINT = 100,
  /* ưɾ (ư << NUM_OF_MOVE_POINT) û롣 */
  /* NUM_OF_MOVE_POINT = 6, */
  NUM_OF_MOVE_POINT = 2,
  /* ֤ᤤȤ˸ݥ */
  OH_HISYA_POINT = 10,
};

/** ׾˽ФƤʳζǼ빽¤ */
typedef struct {
  /** οǼ */
  int count[9];
  /** ƶζ𥳡ɤǼ */
  int number[9][18];
} PBOX;

/** ɽ¤ */
typedef struct {
  /** ưξ */
  int to;
  /** ưξ */
  int fm;
  /** ʤ 1 ʳ 0 򥻥åȤ */
  int nari;
  /** ǤʤǤ ʳ 0 򥻥åȤ */
  int uti;
} TE;

#define MOVEINFOMAX 500

/** ؤޤȤƳǼ빽¤ */
typedef struct {
  /** ؤ */
  TE te[MOVEINFOMAX];
  /** ؤο */
  int count;
} MOVEINFO;

#define MOVEINFO2MAX 2000

/** ؤޤȤƳǼ빽¤ΡĹ */
typedef struct {
  /** ؤ */
  TE te[MOVEINFO2MAX];
  /** ؤο */
  int count;
} MOVEINFO2;

/** ̤ξ֤ɽ¤ */
typedef struct {
  /** ̤ζ */
  int board[256];
  /** ̤ζ𥳡 */
  int noBoard[256];
  /** 𥳡ζȰ */
  int code_xy[41][2];
  /**  */
  int piece[2][8];
  /** μ */
  int next;
  /** Ȣ */
  PBOX pb;
  /** ϥå */
  si_int64 key;
  /** ̤ɾ */
  int point[2];
  /** ϿƤ MOVEINFO2 */
  MOVEINFO2 mi;
  /** ä𤬤äФƤ */
  int tori[MOVEINFO2MAX];
  /** äΥ */
  int tori_count;
  /** ֤ι */
  time_t total_time[2];
  /** » */
  time_t limit_time[2];
  /** ׹ͳλ */
  time_t before_think_time;
  /** ŤĤξ */
  time_t used_time[MOVEINFO2MAX];
} BOARD;

/** ؤĥ꡼˳Ǽ뤿ι¤ */
struct tagTREE {
  /** ľΰ */
  TE te;
  /** ƤؤΥݥ */
  struct tagTREE *parent;
  /** ؤΥݥ */
  struct tagTREE *brother;
  /** ҤؤΥݥ */
  struct tagTREE *child;
  /** ̤ */
  int point;
};

typedef struct tagTREE TREE;

/** ̤Ͽϥåޥå */
typedef struct {
  /** ̥ǡνĤι */
  /* int vboard[3]; */
  /** ϥå奭 */
  si_int64 key;
  /** ̤ɾ */
  int point;
  /** ;Υơ */
  int mate_stat;
  /**  */
  int piece[ 2 ];
  /** ϿȤμ */
  int count;
  /** ѺѤߤΥե饰 */
  int flguse;
} HASH;

/** οʹԤɬפʾ򽸤᤿¤ */
typedef struct {
  /**  */
  TEAI teai;
  /** player number */
  PLAYERTYPE player_number[2];
  /** ϤؿؤΥݥ */
  INPUTSTATUS (*si_input_next[2])(BOARD *bo, TE *te);
  /** ԥ塼λ׹ͥ٥ */
  int computer_level[2];
#ifdef USE_SERIAL
  /** ꥢݡȤȤ̿жɤΤι¤ */
  COMACCESS ca[2];
#endif /* USE_SERIAL */
  /** 1 ξ硢ڤ餱Ȥ */
  int flg_run_out_to_lost;

  /**
   * äȤԤ롼פȴ뤿Υե饰
   * 0 ʤ̤̾ꡣ
   * SI_CHUDAN ʤǤäSI_TORYO ʤλ
   * Ǥޤλä硢Ԥ롼פ餹ȴ롣
   */
  int game_status;
  
  /**
   * ǥե饰ؤΥݥ
   */
  int *chudan;
} GAME;

/* ------------------- function prototype ------------------- */

/* BOARD */
BOARD *newBOARD(void);
BOARD *newBOARDwithInit(void);
void freeBOARD(BOARD *bo);
void boInit(BOARD * bo);
void boPlayInit(BOARD *bo);
void boSetHirate(BOARD * bo);

void boSetPiece(BOARD *bo, int xy, int p);
int boGetPiece(BOARD *bo, int xy);
int boGetNoBoard(BOARD *bo, int xy);
int boGetToBoardCount(int xy, int next);
MOVEINFO * boGetCodeTo(int no);

void boSetNumber(BOARD * bo);
void boSetToBOARD(BOARD * bo);
void boSetToPBOX(BOARD *bo, int x, int y);
BOARD *boCopy(BOARD * bo);
void boCopy2(BOARD *src, BOARD *dest);
void boPushPiece(BOARD *bo, int p);
void boPushPiece2(BOARD *bo, int p, int next);
void boSetPiece3(BOARD *bo, int p, int num, int next);
void boPopToBoard(BOARD *bo, int xy);
void boPushToBoard(BOARD *bo, int xy);
int boMove(BOARD *bo, TE *te, int next);
void boBack(BOARD *bo, int next);
void boMove_mate(BOARD *bo, TE *te, int next);
void boBack_mate(BOARD *bo, int next);
void boPopRemotePiece(BOARD *bo, int xy, MOVEINFO *mi);
int boCmp(BOARD *bo1, BOARD *bo2);
void boSetTsumeShogiPiece(BOARD *bo);
int boCheckTE(BOARD *bo, TE *te);
int boCheckTEOhte(BOARD *bo, TE *te);
void boToggleNext(BOARD *bo);
int boCanNari(BOARD *bo, TE *te);
void boSetNowTime(BOARD *bo);
void boSetUsedTime(BOARD *bo);
int boCheckJustGame(BOARD *bo);
int boCheckJustMate(BOARD *bo);

/* MOVEINFO */
MOVEINFO *newMOVEINFO(void);
void freeMOVEINFO(MOVEINFO *mi);
void miAppend(MOVEINFO * mi, TE * te);
void miAppendNari(MOVEINFO * mi, TE * te, int next);
void miAdd(MOVEINFO * mi, TE * te);
void miAddWithNari(MOVEINFO * mi, TE * te, int next);
void miAddWithNari2(MOVEINFO * mi, TE te, int p, int next);
void miAddWithNariSente(MOVEINFO * mi, TE * te);
void miAddWithNariGote(MOVEINFO * mi, TE * te);
TE *miGet(MOVEINFO *mi, int index);
void miRemoveTE(MOVEINFO *mi, TE *te );
void miRemoveTE2(MOVEINFO *mi, int num );
void miRemoveDuplicationTE(MOVEINFO *mi);
void miCopy(MOVEINFO *dest, MOVEINFO *src);

/* MOVEINFO */
MOVEINFO2 *newMOVEINFO2(void);
void freeMOVEINFO2(MOVEINFO2 *mi);
void mi2Add(MOVEINFO2 * mi, TE * te);
void mi2Copy(MOVEINFO2 *dest, MOVEINFO2 *src);

/* TE */
TE *newTE(int x, int y, int v, int w, int nari);
#ifndef USE_MISC_MACRO
int teCmpTE( TE *te1, TE * te2 );
#endif /* USE_MISC_MACRO */
void teSetTE(TE *te, int fm, int to, int nari, int uti);
int teCSAimoto(TE *te);
int teCSAisaki(TE *te);
int teCSAinaru(TE *te);
void teCSASet(TE *te, int imoto, int isaki);

/* moveto */
void moveto(BOARD * bo, int xy, MOVEINFO *mi);
void moveto_add(BOARD * bo, int xy, MOVEINFO *mi);
void movetoKiki(BOARD * bo, int xy, MOVEINFO *mi);
void moveto2(BOARD *bo, MOVEINFO *mi, int xy, int next);
void moveto2_add(BOARD *bo, MOVEINFO *mi, int xy, int next);

/* pbox */
PBOX *newPBOX(void);
void freePBOX(PBOX *pb);
void pbInit(PBOX * pb);
void pbPush(PBOX * pb, int p);
int pbPop(PBOX * pb, int p);
int pbCheck(PBOX * pb);

/* ohte */
void ohte(BOARD *bo, MOVEINFO *mi);

void normalOhte(BOARD *bo, MOVEINFO *mi, int king_xy);
void remoteOhte(BOARD *bo, MOVEINFO *mi, int king_xy);
void keiOhte(BOARD *bo, MOVEINFO *mi, int king_xy);
void utiOhte(BOARD *bo, MOVEINFO *mi, int king_xy);
void UtiOhte2(BOARD *bo, MOVEINFO *mi, int king_xy);
void akiOhte(BOARD *bo, MOVEINFO *mi, int king_xy);

/* uke */
void uke(BOARD *bo, MOVEINFO *mi, int next);
int countKiki(BOARD *bo, int king_xy, int *rxy, int next);
int ukeRemoteKiki(BOARD *bo, int xy, int next);
int ukeAkiohte(BOARD *bo, TE *te, int king_xy, int next);

/* mate */
MATESTATUS mate(BOARD *bo, TREE *tree, int gn);
MATESTATUS cmate(BOARD *bo, TREE *tree, int gn);

/* tree */
TREE *newTREE(void);
void initTREE(TREE *tree);
void freeTREE(TREE *tree);
void trSetMoveinfo(TREE *tree, MOVEINFO *mi);

/* hash */
void newHASH(void);
void initHASH(void);
void freeHASH(void);
si_int64 hsGetHashKey(BOARD *bo);
void hsPutBOARD(BOARD *bo, int p, int count, int r_count);
int hsGetBOARD(BOARD *bo, int *p, int count, int r_count);
void hsPutBOARDMinMax(BOARD *bo, int point, int count, int r_count);
int hsGetBOARDMinMax(BOARD *bo, int *point, int count, int r_count);
void add_hash_value(BOARD *bo, int xy);
void sub_hash_value(BOARD *bo, int xy);
void hsSetPiece(HASH *hs, BOARD *bo);
int hsSuperiorBOARD(HASH *hs, BOARD *bo);
int hsCmpPiece(HASH *hs, BOARD *bo, int next);

/* grade */
int grade(BOARD *bo, int next);
void add_grade(BOARD *bo, int xy, int next );
void sub_grade(BOARD *bo, int xy, int next );
void add_piece_grade(BOARD *bo, int piece, int next );
void sub_piece_grade(BOARD *bo, int piece, int next );
int oh_safe_grade(BOARD *bo, int king_xy, int next);
void add_oh_safe_grade(BOARD *bo, int next);
void sub_oh_safe_grade(BOARD *bo, int next);
void add_moving_grade(BOARD *bo, int xy, int next);
void sub_moving_grade(BOARD *bo, int xy, int next);

/* search */
void search_011(BOARD *bo, MOVEINFO *mi);
void search_012(BOARD *bo, MOVEINFO *mi);
void search_013(BOARD *bo, MOVEINFO *mi);
void search_014(BOARD *bo, MOVEINFO *mi);
void search_022(BOARD *bo, MOVEINFO *mi);
void search_023(BOARD *bo, MOVEINFO *mi);
void search_024a(BOARD *bo, MOVEINFO *mi);
void search_027(BOARD *bo, MOVEINFO *mi);
void search_031a(BOARD *bo, MOVEINFO *mi);
void search_031b(BOARD *bo, MOVEINFO *mi);
void search_041(BOARD *bo, MOVEINFO *mi);
void search_044(BOARD *bo, MOVEINFO *mi);
void search_046(BOARD *bo, MOVEINFO *mi);
void search_047(BOARD *bo, MOVEINFO *mi);
void search_048(BOARD *bo, MOVEINFO *mi);
void search_049(BOARD *bo, MOVEINFO *mi);
void search_053(BOARD *bo, MOVEINFO *mi);
void search_068(BOARD *bo, MOVEINFO *mi);
void search_pressure(BOARD *bo, MOVEINFO *mi, int to_xy, int next);
void search_pressure_uti(BOARD *bo, MOVEINFO *mi, int to_xy, int next);


/* play */
void play(BOARD *bo, GAME *gm);
void play_move(BOARD *bo, TE *te);
void getTE2SerialString(char *buf, BOARD *bo, TE *te);
void play_lost(BOARD *bo, GAME *gm);
void play_toryo(BOARD *bo, GAME *gm);
void play_win(BOARD *bo, GAME *gm);
void play_chudan(BOARD *bo, GAME *gm);
void play_chudan_recv(BOARD *bo, GAME *gm);
void play_ngdata(BOARD *bo, GAME *gm);
void putHelp(void);

/* think */
void think(BOARD *bo, MOVEINFO *mi, int depth);

/* minmax */
INPUTSTATUS minmax(BOARD *bo);
int f_min(BOARD *bo, int depth, int alpha, int beta);
int f_max(BOARD *bo, int depth, int alpha, int beta);

/* GAME */
GAME *newGAME(void);
void initGAME(GAME *game);
void freeGAME(GAME *game);
INPUTSTATUS (*gmGetInputNextPlayer(GAME *gm, int next))(BOARD *, TE *);
char *gmGetDeviceName(GAME *gm, int next);
int gmGetComputerLevel(GAME *gm, int next);
void gmSetInputFunc(GAME *gm, int next, PLAYERTYPE p);
void gmSetDeviceName(GAME *gm, int next, char *s);
void gmSetGameStatus(GAME *gm, int status);
int gmGetGameStatus(GAME *gm);
void gmSetChudan(GAME *gm, int *chudan);
int *gmGetChudan(GAME *gm);
int gmGetChudanFlg(GAME *gm);

/* misc */

void si_abort(char *s);
void time2string(char *buf, time_t t);

#ifdef USE_MISC_MACRO
/* macro */
#define isGote(b,x,y) (((b)->board[ ((y)<<4) + (x) ])&0x10)
/* #define boPushPiece(bo, p) ((bo)->piece[(bo)->next][(p)&0x07]++) */
#define boPushPiece2(bo, p, n) ((bo)->piece[(n)][(p)&0x07]++)
#define miAdd(m, t) ((m)->te[(m)->count++]=*(t))
#define mi2Add(m, t) ((m)->te[(m)->count++]=*(t))
#define miGet(m, i) (&((m)->te[(i)]))
#define getTeban(p) (((p)&0x10)==0x10)
#define teCmpTE(t, u) ((t)->fm != (u)->fm || (t)->to != (u)->to || \
                       (t)->nari != (u)->nari || (t)->uti != (u)->uti )
#define boSetPiece(bo,xy,p) ((bo)->board[(xy)]=(p))
#define boGetPiece(bo,xy) ((bo)->board[(xy)])
#define boGetNoBoard(bo,xy) (bo->noBoard[(xy)])
#define boToggleNext(bo) ((bo)->next = ((bo)->next == 0))
extern int toBoardCount3[2][256];
#define boGetToBoardCount(xy, n) (toBoardCount3[(n)][(xy)])
extern MOVEINFO code_to[41];
#define boGetCodeTo(n) (&(code_to[(n)]))
#else /* USE_MISC_MACRO */
int piece(BOARD *b, int x, int y);
int isGote(BOARD *b, int x, int y);
int getTeban(int p);
#endif /* USE_MISC_MACRO */
int notSentePiece(int p);
int notGotePiece(int p);
int checkFuSente(BOARD *bo, int x);
int checkFuGote(BOARD *bo, int x);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _SI_H_ */
